<?php
putenv("KRB5CCNAME={$_SERVER['KRB5CCNAME']}");
putenv("ALD_DOMAIN=.test.ru");
putenv("USER_DOMAIN_LOGIN=test.ru");

$newResult = <<<XML
<?xml version='1.0' encoding='UTF-8'?>
<result>
</result>
XML;

### Определение перечня уровней
exec("/usr/sbin/userlev", $lvls);
$level = array();
foreach ($lvls as $lvl) {
	$l = explode("  ", $lvl);
	$level[$l[0]] = $l[1];
}
### Определение перечня категорий
exec("/usr/sbin/usercat", $cats);
$category = array();
foreach ($cats as $cat) {
	$c = explode(" ", $cat);
	$category[hexdec($c[0])] = $c[1];
}

### Создание XML-структуры
$Result = new SimpleXMLElement($newResult);
$User = $Result->addChild("user");

### Подключение к базе данных
$krb_username = explode('@', $_SERVER['REMOTE_USER'])[0];
$strConn = "host=srv1.test.ru port=9060 dbname=contrprimer user={$krb_username}";
$conn = pg_connect($strConn);
if ($conn) {
	### Получение данных о пользователе
	$rows = pg_query("select current_user, session_maclabel;");
	if ($rows) {
		$user = pg_fetch_array($rows, NULL, PGSQL_ASSOC);
		$User["login"] = $user["current_user"];
		$m = substr($user["session_maclabel"], 1, strlen($user["session_maclabel"])-2);
		$metka = explode(",", $m);
		$User["lvl"] = $metka[0];
		$User["level"] = $level[$metka[0]];
		foreach ($category as $k=>$v) {
			if (hexdec($metka[1]) & $k) {
				$Cat = $User->addChild('category');
				$Cat["cat"] = $k;
				$Cat["name"] = $v;
			}
		}
	}
	# Получение данных запроса
	$query1 = "select rab.maclabel,* from rab left join org using(inn);";
	$query2 = "select rab.maclabel,* from rab left join org using(inn) left join kp using(shifr);";
	if (array_key_exists("query", $_GET) && ($GET["q"] = 2) ) {
		$rows = pg_query($query2);
	} else {
		$rows = pg_query($query1);
	}
	if ($rows) {
		while ($row = pg_fetch_array($rows, NULL, PGSQL_ASSOC)) {
			$Rabota = $Result->addChild('rabota');
			foreach ($row as $n => $v) { $Rabota[$n] = $v; }
			$m = substr($row["maclabel"], 1, strlen($row["maclabel"])-2);
			$metka = explode(",", $m);
			$Rabota["lvl"] = $metka[0];
			$Rabota["level"] = $level[$metka[0]];
			$Rabota["cat"] = $metka[1];
		}
	} else {
		$Error = $Result->addChild('error');
		$Error["msg"] = pg_last_error();
	}

	### Отключение от базы данных
	pg_close($conn);
} else {
	die("Не удалось подключиться к базе данных.");
}
#$Result->asXML("result.xml");
echo $Result->asXML();
header("Content-Type: text/xml");
?>
