#!/bin/bash

SCRIPT="$(readlink -f "$0")"
SCRIPT_DIR="$(dirname "$SCRIPT")"

COMMON_SCRIP_DIR="$SCRIPT_DIR/common"
LIB_SCRIPT_DIR="$COMMON_SCRIP_DIR/lib"

source "$LIB_SCRIPT_DIR/globals.sh"
source "$LIB_SCRIPT_DIR/utils.sh"


function main() {
    validate_user

    info_d "###### Проведение тестирования ######"

    pdpl-file 3::0xffffffffffff:CCNRA "$TMP_TEST_PATH"

    cp "${COMMON_SCRIP_DIR}/tests.sh" "$TMP_TEST_SH"
    cp "${COMMON_SCRIP_DIR}/curl_negot_req.sh" "$TMP_CURL_NEGOT_REQ_SH"
    cp "${COMMON_SCRIP_DIR}/curl_req.sh" "$TMP_CURL_REQ_SH"

    chmod 777 "$TMP_TEST_SH"
    chmod 777 "$TMP_CURL_NEGOT_REQ_SH"
    chmod 777 "$TMP_CURL_REQ_SH"

    "$TMP_TEST_SH" "${USR_TEST_DIR}" "${SERVER_NAME}" "$TMP_CURL_NEGOT_REQ_SH" "$TMP_CURL_REQ_SH"
    exit_code=$?

    rm -f "$TMP_TEST_SH"
    rm -f "$TMP_CURL_NEGOT_REQ_SH"
    rm -f "$TMP_CURL_REQ_SH"

    pdpl-file 0:0:0:0 "$TMP_TEST_PATH"

    exit $exit_code
}

main

